package dameng.test;
import java.io.IOException;
import java.io.Reader;
import java.sql.SQLException;
import java.util.List;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import com.ibatis.common.resources.Resources;
import com.ibatis.sqlmap.client.SqlMapClient;
import com.ibatis.sqlmap.client.SqlMapClientBuilder;
import dameng.pojo.ProductCategory;
public class TestProduct {
	SqlMapClient sqlMap = null;
	Reader reader = null;
	@Before
	public void before() {
		try {
			//1. ȡSqlMapConfig.xmlļ
			reader = Resources.getResourceAsReader("SqlMapConfig.xml");
			//2. ͨȡļ sqlMap
			sqlMap = SqlMapClientBuilder.buildSqlMapClient(reader);
		} catch (IOException e) {
			e.printStackTrace();
		} 
	}
	//ԲϢ
    @Test
    public void testInstert(){
    	try {
    		//ע˴sqlmap ôݵַ  Ӧxmlļsql ID Ӧ
			sqlMap.insert("insertProductCategory",new ProductCategory(null, ""));
		} catch (SQLException e) {
			e.printStackTrace();
		}
    }
    //޸Ϣ
    @Test
    public void testUpdate(){
    	ProductCategory productCategory;
		try {
			productCategory = (ProductCategory) sqlMap.queryForObject("selectProductCategoryById",4);
			productCategory.setName("Ӣ5");
			//ע˴sqlmap ôݵַ  Ӧxmlļsql ID Ӧ
			sqlMap.update("updateProductCategory", productCategory);
		} catch (SQLException e) {
			e.printStackTrace();
		}
    }
    //ԸidѯָϢ
    @Test
    public void testSelectPersonById(){
    	ProductCategory productCategory;
    	try {
    		//ע˴sqlmap ôݵַ  Ӧxmlļsql ID Ӧ
			productCategory = (ProductCategory) sqlMap.queryForObject("selectProductCategoryById",4);
			System.out.println(productCategory);
		} catch (SQLException e) {
			e.printStackTrace();
		}
    }
    //ȫ
    @Test
    public void testSelectAll(){
    	List<ProductCategory> list;
		try {
			//ע˴sqlmap ôݵַ  Ӧxmlļsql ID Ӧ
			list = sqlMap.queryForList("selectAll");
			for(ProductCategory p: list){
	            System.out.println(p);
	        }
		} catch (SQLException e) {
			e.printStackTrace();
		}
    }
    //ɾ
    @Test
    public void testDelete(){
    	try {
    		//ע˴sqlmap ôݵַ  Ӧxmlļsql ID Ӧ
			sqlMap.delete("deleteById",5);
		} catch (SQLException e) {
			e.printStackTrace();
		}
    }
    
    @After
    public void after() {
    	try {
			reader.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
    }
	public static void main(String[] args) {
		TestProduct test = new TestProduct();
		test.before();
		test.testInstert();
		test.testUpdate();
        test.testSelectPersonById();
        test.testSelectAll();
        test.testDelete();
	}
}
